package lm.semaforo.widgets;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ServiceHelper;
import anywheresoftware.b4a.debug.*;

public class widgetservice extends android.app.Service {
	public static class widgetservice_BR extends android.content.BroadcastReceiver {

		@Override
		public void onReceive(android.content.Context context, android.content.Intent intent) {
			android.content.Intent in = new android.content.Intent(context, widgetservice.class);
			if (intent != null)
				in.putExtra("b4a_internal_intent", intent);
			context.startService(in);
		}

	}
    static widgetservice mostCurrent;
	public static BA processBA;
    private ServiceHelper _service;
    public static Class<?> getObject() {
		return widgetservice.class;
	}
	@Override
	public void onCreate() {
        mostCurrent = this;
        if (processBA == null) {
		    processBA = new BA(this, null, null, "lm.semaforo.widgets", "lm.semaforo.widgets.widgetservice");
            try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            processBA.loadHtSubs(this.getClass());
            ServiceHelper.init();
        }
        _service = new ServiceHelper(this);
        processBA.service = this;
        processBA.setActivityPaused(false);
        if (BA.shellMode) {
			processBA.raiseEvent2(null, true, "CREATE", true, "lm.semaforo.widgets.widgetservice", processBA, _service);
		}
        BA.LogInfo("** Service (widgetservice) Create **");
        processBA.raiseEvent(null, "service_create");
    }
		@Override
	public void onStart(android.content.Intent intent, int startId) {
		handleStart(intent);
    }
    @Override
    public int onStartCommand(android.content.Intent intent, int flags, int startId) {
    	handleStart(intent);
		return android.app.Service.START_NOT_STICKY;
    }
    private void handleStart(android.content.Intent intent) {
    	BA.LogInfo("** Service (widgetservice) Start **");
    	java.lang.reflect.Method startEvent = processBA.htSubs.get("service_start");
    	if (startEvent != null) {
    		if (startEvent.getParameterTypes().length > 0) {
    			anywheresoftware.b4a.objects.IntentWrapper iw = new anywheresoftware.b4a.objects.IntentWrapper();
    			if (intent != null) {
    				if (intent.hasExtra("b4a_internal_intent"))
    					iw.setObject((android.content.Intent) intent.getParcelableExtra("b4a_internal_intent"));
    				else
    					iw.setObject(intent);
    			}
    			processBA.raiseEvent(null, "service_start", iw);
    		}
    		else {
    			processBA.raiseEvent(null, "service_start");
    		}
    	}
    }
	@Override
	public android.os.IBinder onBind(android.content.Intent intent) {
		return null;
	}
	@Override
	public void onDestroy() {
        BA.LogInfo("** Service (widgetservice) Destroy **");
		processBA.raiseEvent(null, "service_destroy");
        processBA.service = null;
		mostCurrent = null;
		processBA.setActivityPaused(true);
	}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.RemoteViewsWrapper _rv = null;
public static String[] _imagefiles = null;
public static int _currentimage = 0;
public lm.semaforo.widgets.main _main = null;
public static String  _imageview1_click() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub ImageView1_Click";
 //BA.debugLineNum = 39;BA.debugLine="currentImage = (currentImage + 1) Mod imageFiles.Length";
_currentimage = (int) ((_currentimage+1)%_imagefiles.length);
 //BA.debugLineNum = 40;BA.debugLine="rv.SetImage(\"ImageView1\", LoadBitmap(File.DirAssets, imageFiles(currentImage)))";
_rv.SetImage(processBA,"ImageView1",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),_imagefiles[_currentimage]).getObject()));
 //BA.debugLineNum = 43;BA.debugLine="rv.UpdateWidget";
_rv.UpdateWidget(processBA);
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 7;BA.debugLine="Dim rv As RemoteViews";
_rv = new anywheresoftware.b4a.objects.RemoteViewsWrapper();
 //BA.debugLineNum = 8;BA.debugLine="Dim imageFiles() As String";
_imagefiles = new String[(int) (0)];
java.util.Arrays.fill(_imagefiles,"");
 //BA.debugLineNum = 9;BA.debugLine="imageFiles = Array As String(\"SRosso.png\", \"SGiallo.png\", \"SVerde.png\")";
_imagefiles = new String[]{"SRosso.png","SGiallo.png","SVerde.png"};
 //BA.debugLineNum = 10;BA.debugLine="Dim currentImage As Int";
_currentimage = 0;
 //BA.debugLineNum = 11;BA.debugLine="End Sub";
return "";
}
public static String  _rv_disabled() throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub rv_Disabled";
 //BA.debugLineNum = 27;BA.debugLine="StopService(\"\")";
anywheresoftware.b4a.keywords.Common.StopService(processBA,(Object)(""));
 //BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
public static String  _rv_requestupdate() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub rv_RequestUpdate";
 //BA.debugLineNum = 23;BA.debugLine="rv.UpdateWidget";
_rv.UpdateWidget(processBA);
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _service_create() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Service_Create";
 //BA.debugLineNum = 14;BA.debugLine="rv = ConfigureHomeWidget(\"L1\", \"rv\", 0, \"Semaforo Widget\")";
_rv = anywheresoftware.b4a.objects.RemoteViewsWrapper.createRemoteViews(processBA, R.layout.widgetservice_layout, "L1","rv");
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return "";
}
public static String  _service_destroy() throws Exception{
 //BA.debugLineNum = 30;BA.debugLine="Sub Service_Destroy";
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _service_start(anywheresoftware.b4a.objects.IntentWrapper _startingintent) throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Service_Start (StartingIntent As Intent)";
 //BA.debugLineNum = 18;BA.debugLine="If rv.HandleWidgetEvents(StartingIntent) Then Return";
if (_rv.HandleWidgetEvents(processBA,(android.content.Intent)(_startingintent.getObject()))) { 
if (true) return "";};
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _settime() throws Exception{
 //BA.debugLineNum = 34;BA.debugLine="Sub SetTime";
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
}
